<?php

namespace DataView;

class Fop_fints_tanMode {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
									
									function updateNumberfop_fints_tanMode(col) {
										//var checklist = window.DataViewChecked['fop_fints_tanMode'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_fints_tanMode'] && window.DataViewChecked['fop_fints_tanMode'][col].ranges.length > 0) {
											$('.fop_fints_tanMode__mass-action').css('visibility', 'visible');
											$('.fop_fints_tanMode__action').css('visibility', 'hidden');
										} else {
											$('.fop_fints_tanMode__mass-action').css('visibility', 'hidden');
											$('.fop_fints_tanMode__action').css('visibility', 'visible');
										}
										$('.fop_fints_tanMode__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_fints_tanMode__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_fints_tanMode__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_fints_tanMode (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_fints_tanMode/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_fints_tanMode/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_fints_tanMode-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_fints_tanMode-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_fints_tanMode-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_fints_tanMode('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_fints_tanMode-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_fints_tanMode()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_fints_tanMode (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_fints_tanMode']) window.DataViewChecked['fop_fints_tanMode'] = {};
										if (!window.DataViewChecked['fop_fints_tanMode'][col]) window.DataViewChecked['fop_fints_tanMode'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_fints_tanMode'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_fints_tanMode({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_fints_tanMode'][col] = new IDList(ids);
													updateNumberfop_fints_tanMode(col);
												});
											} else {
												window.DataViewChecked['fop_fints_tanMode'][col] = new IDList();
												updateNumberfop_fints_tanMode(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_fints_tanMode__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_fints_tanMode'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_fints_tanMode'][col].push(id);
												} else {
													window.DataViewChecked['fop_fints_tanMode'][col].remove(id);
												}
											}
											updateNumberfop_fints_tanMode(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_fints_tanMode();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((false))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadfop_fints_tanMode({action: 'open', fop_table: 'fop_fints_tanMode', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Fop_fints_tanMode::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Tan Modes'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_fints_tanMode']) ? intval($_GET['page_fop_fints_tanMode']) : 0);
								$addlines = (isset($_GET['addlines_fop_fints_tanMode']) ? intval($_GET['addlines_fop_fints_tanMode']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'tanMode',
												'desc' => _('tanMode'),
												'order' => ++$order,
												'width' => 60, // default value
												'collapsed' => 0

											];
											$columns['tanMode'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'tanName',
												'desc' => _('tanName'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['tanName'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'tanMediaName',
												'desc' => _('tanMediaName'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['tanMediaName'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'konto',
												'desc' => _('konto'),
												'order' => ++$order,
												'width' => 60, // default value
												'collapsed' => 0

											];
											$columns['konto'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_fints_tanMode'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='tanMode'
												data-order='<?php echo intval($columns['tanMode']['order']); ?>'
												data-width='<?php echo intval($columns['tanMode']['width']); ?>'
												data-collapsed='<?php echo intval($columns['tanMode']['collapsed']); ?>'
												style='width: <?php echo intval($columns['tanMode']['width']); ?>px; <?php if ($columns['tanMode']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_tanMode(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_fop_fints_tanMode_tanMode']).on('change keyup paste', function () { query['range_min_fop_fints_tanMode_tanMode'] = von.val(); delete query['page_fop_fints_tanMode']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_fop_fints_tanMode_tanMode']).on('change keyup paste', function () { query['range_max_fop_fints_tanMode_tanMode'] = bis.val(); delete query['page_fop_fints_tanMode']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_tanMode'] == 'tanMode ASC') {
			query['sort_fop_fints_tanMode'] = 'tanMode DESC';
		 } else if (query['sort_fop_fints_tanMode'] == 'tanMode DESC') {
		 	delete query['sort_fop_fints_tanMode'];
		 } else {
			query['sort_fop_fints_tanMode'] = 'tanMode ASC';
		 }
		 reloadfop_fints_tanMode();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('tanMode')); ?>'><?php echo(_('tanMode')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'tanMode ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'tanMode DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_tanMode_tanMode']) || isset($_GET['range_max_fop_fints_tanMode_tanMode']) || isset($_GET['deps_fop_fints_tanMode_tanMode']) || isset($_GET['fullsearch_fop_fints_tanMode_tanMode']) || isset($_GET['dynamic_fop_fints_tanMode_tanMode']) || isset($_GET['search_fop_fints_tanMode_tanMode']) || isset($_GET['searchnot_fop_fints_tanMode_tanMode']) || isset($_GET['filter_fop_fints_tanMode_tanMode'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['tanMode']['header'] = ob_get_contents(); ob_end_clean();
											$columns['tanMode']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['tanMode']['width']); ?>px; <?php if ($columns['tanMode']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='tanMode'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Integer::print($item['tanMode'])); ?>
	</span></div><?php
											};
											$columns['tanMode']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='tanMode'
													data-order='<?php echo intval($columns['tanMode']['order']); ?>'
													data-width='<?php echo intval($columns['tanMode']['width']); ?>'
													data-collapsed='<?php echo intval($columns['tanMode']['collapsed']); ?>'
													style='width: <?php echo intval($columns['tanMode']['width']); ?>px; <?php if ($columns['tanMode']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='tanName'
												data-order='<?php echo intval($columns['tanName']['order']); ?>'
												data-width='<?php echo intval($columns['tanName']['width']); ?>'
												data-collapsed='<?php echo intval($columns['tanName']['collapsed']); ?>'
												style='width: <?php echo intval($columns['tanName']['width']); ?>px; <?php if ($columns['tanName']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_tanMode(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_fints_tanMode_tanName'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_fints_tanMode_tanName'] = text.val(); } else { delete query['search_fop_fints_tanMode_tanName']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_fints_tanMode').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_fints_tanMode_tanName'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_fints_tanMode_tanName'] = text2.val(); } else { delete query['searchnot_fop_fints_tanMode_tanName']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_fints_tanMode').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_tanMode'] == 'tanName ASC') {
			query['sort_fop_fints_tanMode'] = 'tanName DESC';
		 } else if (query['sort_fop_fints_tanMode'] == 'tanName DESC') {
		 	delete query['sort_fop_fints_tanMode'];
		 } else {
			query['sort_fop_fints_tanMode'] = 'tanName ASC';
		 }
		 reloadfop_fints_tanMode();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('tanName')); ?>'><?php echo(_('tanName')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'tanName ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'tanName DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_tanMode_tanName']) || isset($_GET['range_max_fop_fints_tanMode_tanName']) || isset($_GET['deps_fop_fints_tanMode_tanName']) || isset($_GET['fullsearch_fop_fints_tanMode_tanName']) || isset($_GET['dynamic_fop_fints_tanMode_tanName']) || isset($_GET['search_fop_fints_tanMode_tanName']) || isset($_GET['searchnot_fop_fints_tanMode_tanName']) || isset($_GET['filter_fop_fints_tanMode_tanName'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['tanName']['header'] = ob_get_contents(); ob_end_clean();
											$columns['tanName']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['tanName']['width']); ?>px; <?php if ($columns['tanName']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='tanName'><span class='overflow-text' title="<?php echo htmlentities($item['tanName']); ?>"><?php echo htmlentities($item['tanName']); ?></span></div><?php
											};
											$columns['tanName']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='tanName'
													data-order='<?php echo intval($columns['tanName']['order']); ?>'
													data-width='<?php echo intval($columns['tanName']['width']); ?>'
													data-collapsed='<?php echo intval($columns['tanName']['collapsed']); ?>'
													style='width: <?php echo intval($columns['tanName']['width']); ?>px; <?php if ($columns['tanName']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='tanMediaName'
												data-order='<?php echo intval($columns['tanMediaName']['order']); ?>'
												data-width='<?php echo intval($columns['tanMediaName']['width']); ?>'
												data-collapsed='<?php echo intval($columns['tanMediaName']['collapsed']); ?>'
												style='width: <?php echo intval($columns['tanMediaName']['width']); ?>px; <?php if ($columns['tanMediaName']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_tanMode(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_fints_tanMode_tanMediaName'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_fints_tanMode_tanMediaName'] = text.val(); } else { delete query['search_fop_fints_tanMode_tanMediaName']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_fints_tanMode').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_fints_tanMode_tanMediaName'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_fints_tanMode_tanMediaName'] = text2.val(); } else { delete query['searchnot_fop_fints_tanMode_tanMediaName']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_fints_tanMode').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_tanMode'] == 'tanMediaName ASC') {
			query['sort_fop_fints_tanMode'] = 'tanMediaName DESC';
		 } else if (query['sort_fop_fints_tanMode'] == 'tanMediaName DESC') {
		 	delete query['sort_fop_fints_tanMode'];
		 } else {
			query['sort_fop_fints_tanMode'] = 'tanMediaName ASC';
		 }
		 reloadfop_fints_tanMode();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('tanMediaName')); ?>'><?php echo(_('tanMediaName')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'tanMediaName ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'tanMediaName DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_tanMode_tanMediaName']) || isset($_GET['range_max_fop_fints_tanMode_tanMediaName']) || isset($_GET['deps_fop_fints_tanMode_tanMediaName']) || isset($_GET['fullsearch_fop_fints_tanMode_tanMediaName']) || isset($_GET['dynamic_fop_fints_tanMode_tanMediaName']) || isset($_GET['search_fop_fints_tanMode_tanMediaName']) || isset($_GET['searchnot_fop_fints_tanMode_tanMediaName']) || isset($_GET['filter_fop_fints_tanMode_tanMediaName'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['tanMediaName']['header'] = ob_get_contents(); ob_end_clean();
											$columns['tanMediaName']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['tanMediaName']['width']); ?>px; <?php if ($columns['tanMediaName']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='tanMediaName'><span class='overflow-text' title="<?php echo htmlentities($item['tanMediaName']); ?>"><?php echo htmlentities($item['tanMediaName']); ?></span></div><?php
											};
											$columns['tanMediaName']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='tanMediaName'
													data-order='<?php echo intval($columns['tanMediaName']['order']); ?>'
													data-width='<?php echo intval($columns['tanMediaName']['width']); ?>'
													data-collapsed='<?php echo intval($columns['tanMediaName']['collapsed']); ?>'
													style='width: <?php echo intval($columns['tanMediaName']['width']); ?>px; <?php if ($columns['tanMediaName']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='konto'
												data-order='<?php echo intval($columns['konto']['order']); ?>'
												data-width='<?php echo intval($columns['konto']['width']); ?>'
												data-collapsed='<?php echo intval($columns['konto']['collapsed']); ?>'
												style='width: <?php echo intval($columns['konto']['width']); ?>px; <?php if ($columns['konto']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_tanMode(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_fop_fints_tanMode_konto']).on('change keyup paste', function () { query['range_min_fop_fints_tanMode_konto'] = von.val(); delete query['page_fop_fints_tanMode']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_fop_fints_tanMode_konto']).on('change keyup paste', function () { query['range_max_fop_fints_tanMode_konto'] = bis.val(); delete query['page_fop_fints_tanMode']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_tanMode'] == 'konto ASC') {
			query['sort_fop_fints_tanMode'] = 'konto DESC';
		 } else if (query['sort_fop_fints_tanMode'] == 'konto DESC') {
		 	delete query['sort_fop_fints_tanMode'];
		 } else {
			query['sort_fop_fints_tanMode'] = 'konto ASC';
		 }
		 reloadfop_fints_tanMode();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('konto')); ?>'><?php echo(_('konto')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'konto ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_tanMode']) && $_GET['sort_fop_fints_tanMode'] == 'konto DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_tanMode_konto']) || isset($_GET['range_max_fop_fints_tanMode_konto']) || isset($_GET['deps_fop_fints_tanMode_konto']) || isset($_GET['fullsearch_fop_fints_tanMode_konto']) || isset($_GET['dynamic_fop_fints_tanMode_konto']) || isset($_GET['search_fop_fints_tanMode_konto']) || isset($_GET['searchnot_fop_fints_tanMode_konto']) || isset($_GET['filter_fop_fints_tanMode_konto'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['konto']['header'] = ob_get_contents(); ob_end_clean();
											$columns['konto']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['konto']['width']); ?>px; <?php if ($columns['konto']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='konto'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Integer::print($item['konto'])); ?>
	</span></div><?php
											};
											$columns['konto']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='konto'
													data-order='<?php echo intval($columns['konto']['order']); ?>'
													data-width='<?php echo intval($columns['konto']['width']); ?>'
													data-collapsed='<?php echo intval($columns['konto']['collapsed']); ?>'
													style='width: <?php echo intval($columns['konto']['width']); ?>px; <?php if ($columns['konto']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_fints_tanMode-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_fints_tanMode-table .fop-table-header .fop-table-column .title,
										#fop_fints_tanMode-table .fop-column-handle,
										#fop_fints_tanMode-table .fop-table-row,
										#fop_fints_tanMode-table .fop-table-row .fop-table-column,
										#fop_fints_tanMode-table .fop-table-column-multicontrol,
										#fop_fints_tanMode-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_fints_tanMode">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_fints_tanMode__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_fints_tanMode__all-checkbox" type="checkbox" onchange="checkfop_fints_tanMode('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_fints_tanMode__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_fints_tanMode/permissions?id=' + checkfop_fints_tanMode(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_fints_tanMode_') == 0 || key.indexOf('range_max_fop_fints_tanMode_') == 0 || key.indexOf('deps_fop_fints_tanMode_') == 0 || key.indexOf('fullsearch_fop_fints_tanMode_') == 0 || key.indexOf('dynamic_fop_fints_tanMode_') == 0 || key.indexOf('search_fop_fints_tanMode_') == 0 || key.indexOf('searchnot_fop_fints_tanMode_') == 0 || key.indexOf('filter_fop_fints_tanMode_') == 0) delete query[key]; reloadfop_fints_tanMode(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_fints_tanMode_ID'] = checkfop_fints_tanMode(null, 'ID'); delete query['page_fop_fints_tanMode']; reloadfop_fints_tanMode(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_fints_tanMode(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_fints_tanMode(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && (!\FOP\User::getIsGuest())) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_fints_tanMode/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_fints_tanMode(null, 'ID'))).then(function () { reloadfop_fints_tanMode(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_fints_tanMode', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_fints_tanMode', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_fints_tanMode" <?php \EasyEditor\Navigation::printScroll('dv.Fop_fints_tanMode', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_fints_tanMode\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_fints_tanMode\'] = wantedPage;
														reloadfop_fints_tanMode(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-fop_fints_tanMode-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadfop_fints_tanMode({action: \'open\', fop_table: \'fop_fints_tanMode\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_fints_tanMode__checkbox fop_fints_tanMode__checkbox fop_fints_tanMode__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_fints_tanMode__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_fints_tanMode__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_fints_tanMode(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_fints_tanMode__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_fints_tanMode-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_tanMode::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadfop_fints_tanMode({action: 'open', fop_table: 'fop_fints_tanMode', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_tanMode::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_fints_tanMode/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_fints_tanMode(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_fints_tanMode" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_fints_tanMode::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_fints_tanMode();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_fints_tanMode" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Fop_fints_tanMode::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadfop_fints_tanMode({action: 'open', fop_table: 'fop_fints_tanMode', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadfop_fints_tanMode();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').') WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_fints_tanMode').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: dependency-fop_fints_tanMode ---
    
		if (isset($params['select']) && $params['select'] == 'fop_fints_tanMode') {
			$deps = ['tanModeDep' => $params['deps_fop_fints_tanMode_tanModeDep']];
		}
	
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* active */ '.qi('active').' AS '.qi('active').',
									/* konto */ '.qi('konto').' AS '.qi('konto').',
									/* operation::create */ (FALSE) AS '.qi('operation::create').',
									/* operation::delete */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::delete').',
									/* operation::edit */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									/* tanMediaName */ '.qi('tanMediaName').' AS '.qi('tanMediaName').',
									/* tanMode */ '.qi('tanMode').' AS '.qi('tanMode').',
									/* tanName */ '.qi('tanName').' AS '.qi('tanName').',
									1
								FROM '.qi('fop_fints_tanMode').' '.qi('fop_fints_tanMode').'
								WHERE (('.(\FOP\User::getIsGuest() ? 'false' : 'true').'))
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'fop_fints_tanMode' ? '((('.qi('fop_fints_tanMode').'.'.qi('active').') = (1)) AND (('.qi('fop_fints_tanMode').'.'.qi('konto').') = (' . \FOP\Database::quote($deps['tanModeDep']) . ')))' : 'TRUE') . ')) AS t
								WHERE ' . (isset($params['range_min_fop_fints_tanMode_tanMode']) ? ($params['range_min_fop_fints_tanMode_tanMode'] !== '' && is_numeric($params['range_min_fop_fints_tanMode_tanMode']) ? 't.'.qi('tanMode').' >= ' . \FOP\Database::quote($params['range_min_fop_fints_tanMode_tanMode']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_fints_tanMode_konto']) ? ($params['range_min_fop_fints_tanMode_konto'] !== '' && is_numeric($params['range_min_fop_fints_tanMode_konto']) ? 't.'.qi('konto').' >= ' . \FOP\Database::quote($params['range_min_fop_fints_tanMode_konto']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_fints_tanMode_tanMode']) ? ($params['range_max_fop_fints_tanMode_tanMode'] !== '' && is_numeric($params['range_max_fop_fints_tanMode_tanMode']) ? 't.'.qi('tanMode').' <= ' . \FOP\Database::quote($params['range_max_fop_fints_tanMode_tanMode']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_fints_tanMode_konto']) ? ($params['range_max_fop_fints_tanMode_konto'] !== '' && is_numeric($params['range_max_fop_fints_tanMode_konto']) ? 't.'.qi('konto').' <= ' . \FOP\Database::quote($params['range_max_fop_fints_tanMode_konto']) . ' AND ' : '') : '') . 
								(isset($params['filter_fop_fints_tanMode_tanMode']) ? ($params['filter_fop_fints_tanMode_tanMode'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_tanMode_tanMode']))->toSQL('t.'.qi('tanMode').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_tanMode_tanName']) ? ($params['filter_fop_fints_tanMode_tanName'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_tanMode_tanName']))->toSQL('t.'.qi('tanName').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_tanMode_tanMediaName']) ? ($params['filter_fop_fints_tanMode_tanMediaName'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_tanMode_tanMediaName']))->toSQL('t.'.qi('tanMediaName').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_tanMode_konto']) ? ($params['filter_fop_fints_tanMode_konto'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_tanMode_konto']))->toSQL('t.'.qi('konto').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_tanMode_ID']) ? ($params['filter_fop_fints_tanMode_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_tanMode_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_fop_fints_tanMode_tanName']) ? 't.'.qi('tanName').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_fints_tanMode_tanName'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_fints_tanMode_tanMediaName']) ? 't.'.qi('tanMediaName').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_fints_tanMode_tanMediaName'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_fints_tanMode_tanName']) ? 'NOT t.'.qi('tanName').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_fints_tanMode_tanName'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_fints_tanMode_tanMediaName']) ? 'NOT t.'.qi('tanMediaName').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_fints_tanMode_tanMediaName'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_fints_tanMode']) ? '(' . 't.'.qi('tanName').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_fints_tanMode'] . '%') . ' OR ' . 't.'.qi('tanMediaName').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_fints_tanMode'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'tanName ASC' => 'ORDER BY t.'.qi('tanName').' ASC',
									'tanMediaName ASC' => 'ORDER BY t.'.qi('tanMediaName').' ASC',
									'tanMode ASC' => 'ORDER BY t.'.qi('tanMode').' ASC',
									'konto ASC' => 'ORDER BY t.'.qi('konto').' ASC',
									'tanName DESC' => 'ORDER BY t.'.qi('tanName').' DESC',
									'tanMediaName DESC' => 'ORDER BY t.'.qi('tanMediaName').' DESC',
									'tanMode DESC' => 'ORDER BY t.'.qi('tanMode').' DESC',
									'konto DESC' => 'ORDER BY t.'.qi('konto').' DESC',
									'' => ''), isset($params['sort_fop_fints_tanMode']) ? $params['sort_fop_fints_tanMode'] : '') ?: '');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['tanMode'] = \Types\Integer::unpack($item['tanMode']);
											$item['konto'] = \Types\Integer::unpack($item['konto']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['tanMode'] = \Types\Integer::unpack($item['tanMode']);
										$item['konto'] = \Types\Integer::unpack($item['konto']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	if (isset($params['range_min_fop_fints_tanMode_tanMode']) && isset($params['range_max_fop_fints_tanMode_tanMode'])) {
		array_push($filters, _('tanMode') . ': ' . (\Types\Integer::print($params['range_min_fop_fints_tanMode_tanMode'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_fints_tanMode_tanMode'])
	));
	} else if (isset($params['range_min_fop_fints_tanMode_tanMode'])) {
		array_push($filters, _('tanMode') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_fints_tanMode_tanMode'])
	));
	} else if (isset($params['range_max_fop_fints_tanMode_tanMode'])) {
		array_push($filters, _('tanMode') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_fints_tanMode_tanMode'])
	));
	}
	if (isset($params['range_min_fop_fints_tanMode_konto']) && isset($params['range_max_fop_fints_tanMode_konto'])) {
		array_push($filters, _('konto') . ': ' . (\Types\Integer::print($params['range_min_fop_fints_tanMode_konto'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_fints_tanMode_konto'])
	));
	} else if (isset($params['range_min_fop_fints_tanMode_konto'])) {
		array_push($filters, _('konto') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_fints_tanMode_konto'])
	));
	} else if (isset($params['range_max_fop_fints_tanMode_konto'])) {
		array_push($filters, _('konto') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_fints_tanMode_konto'])
	));
	}if (isset($params['filter_fop_fints_tanMode_tanMode'])) {
		if ($params['filter_fop_fints_tanMode_tanMode'] == '_null') {
			array_push($filters, _('tanMode') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_tanMode_tanMode']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('tanMode') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_tanMode_tanName'])) {
		if ($params['filter_fop_fints_tanMode_tanName'] == '_null') {
			array_push($filters, _('tanName') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_tanMode_tanName']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('tanName') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_tanMode_tanMediaName'])) {
		if ($params['filter_fop_fints_tanMode_tanMediaName'] == '_null') {
			array_push($filters, _('tanMediaName') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_tanMode_tanMediaName']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('tanMediaName') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_tanMode_konto'])) {
		if ($params['filter_fop_fints_tanMode_konto'] == '_null') {
			array_push($filters, _('konto') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_tanMode_konto']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('konto') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_fop_fints_tanMode_tanName'])) {
		array_push($filters, _('tanName') . ' ' . _('filter_contains') . ' ' . $params['search_fop_fints_tanMode_tanName']);
	}if (isset($params['search_fop_fints_tanMode_tanMediaName'])) {
		array_push($filters, _('tanMediaName') . ' ' . _('filter_contains') . ' ' . $params['search_fop_fints_tanMode_tanMediaName']);
	}if (isset($params['searchnot_fop_fints_tanMode_tanName'])) {
		array_push($filters, _('tanName') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_fints_tanMode_tanName']);
	}if (isset($params['searchnot_fop_fints_tanMode_tanMediaName'])) {
		array_push($filters, _('tanMediaName') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_fints_tanMode_tanMediaName']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_fints_tanMode_\')) delete query[q];} reloadfop_fints_tanMode(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_fints_tanMode') {
	\FOP\Session::setPayload('dv-fop_fints_tanMode', [
		'id' => 'fop_fints_tanMode',
		'tbl' => 'fop_fints_tanMode',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_fints_tanMode::stepURL('fop_fints_tanMode', 'XXX', -1),
		'next' => \DataViewRouter\Fop_fints_tanMode::stepURL('fop_fints_tanMode', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_fints_tanMode::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



